## webdvd 0.2

=== Makefile ===
prefix := /usr/local

webdvd_lib_dir := $(prefix)/lib/webdvd

moz_include_dir := \
    $(shell pkg-config --variable=prefix mozilla-gtkmozembed)/include/mozilla
moz_lib_dir := \
    $(shell pkg-config --variable=prefix mozilla-gtkmozembed)/lib/mozilla

CFLAGS := -Wall
CPPFLAGS := -D_REENTRANT
# Non-virtual destructors are fine in XPCOM interface classes since
# instances are only ever called by the Release function which is virtual.
CXXFLAGS := -Wall -Wno-non-virtual-dtor
LDFLAGS := -lpthread $(shell pkg-config --libs gtkmm-2.0 mozilla-gtkmozembed) \
           -Wl,-rpath -Wl,$(moz_lib_dir)

ifdef NDEBUG
    CPPFLAGS += -DNDEBUG
else
    CFLAGS += -g
    CXXFLAGS += -g
    LDFLAGS += -g
endif

cxxsources := \
    auto_proc.cpp browserwidget.cpp childiterator.cpp framebuffer.cpp \
    linkiterator.cpp pixbufs.cpp stylesheets.cpp webdvd.cpp xpcom_support.cpp
csources := jquant2.c

webdvd : $(cxxsources:.cpp=.o) $(csources:.c=.o)
	$(CXX) $(LDFLAGS) -o $@ $^

clean :
	rm -f webdvd *.d *.o *~ .\#* *.orig *.rej svn-commit*.tmp *.dvdauthor *.png *.vob *.spumux

distclean : clean
	rm -rf .svn

install :
	mkdir -p -m 755 $(prefix)/bin $(prefix)/lib/webdvd
	install -m 755 -s webdvd $(prefix)/bin
	install -m 644 webdvd.css $(prefix)/lib/webdvd

.PHONY : clean distclean install

browserwidget.% : CPPFLAGS += -DMOZ_LIB_DIR='"$(moz_lib_dir)"'

webdvd.% : CPPFLAGS += -DWEBDVD_LIB_DIR='"$(webdvd_lib_dir)"'

browserwidget.% pixbufs.% webdvd.% \
    : CPPFLAGS += $(shell pkg-config --cflags gtkmm-2.0)

browserwidget.% childiterator.o linkiterator.% stylesheets.% webdvd.% \
xpcom_support.%                                                       \
    : CPPFLAGS += $(shell pkg-config --cflags mozilla-gtkmozembed)

# These dig a bit deeper into Mozilla
linkiterator.% stylesheets.% webdvd.%                                        \
    : CPPFLAGS += $(addprefix -I$(moz_include_dir)/,                         \
                    content docshell dom gfx layout necko webshell widget)

%.d : %.cpp
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -MM -MF $@ $<

%.d : %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -MM -MF $@ $<

ifneq ($(MAKECMDGOALS),clean)
    include $(cxxsources:.cpp=.d) $(csources:.c=.d)
endif

# Temporary rule for testing output files.

%.vob : %_back.png %.spumux %_links.png
	pngtopnm $*_back.png                                   \
	| ppmtoy4m -v0 -n 1 -F 25:1 -A 59:54 -I p -S 420_mpeg2 \
	| mpeg2enc -v0 -f 8 -a 2 -o /dev/stdout                \
	| mplex -v0 -f 8 -o /dev/stdout /dev/stdin             \
	| spumux -v0 -m dvd $*.spumux > $@

=== debian/changelog ===
webdvd (0.2) unstable; urgency=low

  * Debianised
  * Corrected length of background filename buffer
  * Worked around bogus error generated by imglib2

 -- Ben Hutchings <ben@decadentplace.org.uk>  Sat, 12 Nov 2005 15:24:07 +0000

webdvd (0.1) unstable; urgency=low

  * Initial version

 -- Ben Hutchings <ben@decadentplace.org.uk>  Thu, 03 Nov 2005 02:04:02 +0000

=== debian/control ===
Source: webdvd
Maintainer: Ben Hutchings <ben@decadentplace.org.uk>
Section: graphics
Priority: extra
Build-Depends: debhelper (>=4), libgtkmm2.0-dev, mozilla-dev
Standards-Version: 3.6.2

Package: webdvd
Architecture: any
Depends: xvfb, xfonts-base, ${shlibs:Depends}, ${mozilla:Depends}
Recommends: dvdauthor, mjpegtools, mkisofs, netpbm
Description: Converts HTML pages into DVD menus.
 WebDVD is intended to provide a simple way of producing DVDs with
 attractive and usable menus.  It converts HTML pages into DVD menus by
 rendering them in Mozilla and reproducing their link structure.  This
 allows you to design DVDs using familiar HTML editing tools or your
 favourite text editor.  This very early version produces a set of
 files suitable for passing to the "dvdauthor" and "spumux" programs,
 but in future it is intended to run the necessary external programs
 automatically.

=== debian/rules ===
#!/usr/bin/make -f

build :
	make prefix=/usr

binary : binary-arch binary-indep

binary-arch : build
	dh_testroot
	make prefix=debian/webdvd/usr install
	dh_strip
	dh_shlibdeps
	@echo "Despite the warnings from dh_shlibdeps, this should complete dependencies:"
	echo "mozilla:Depends=mozilla-browser (= $$(dpkg-query -W --showformat='$${version}' mozilla-browser))" >> debian/webdvd.substvars
	mkdir -p -m755 debian/webdvd/usr/share/doc/webdvd
	cp COPYING debian/webdvd/usr/share/doc/webdvd/copyright
	dh_installchangelogs
	dh_installdocs
	dh_compress
	dh_installdeb
	dh_gencontrol
	dh_builddeb

binary-indep :

clean :
	make clean

svn-build :
	svn-buildpackage \
	--svn-builder='pdebuild-dist $(if $(DIST),$(DIST),sid)'

.PHONY : build binary binary-arch binary-dep clean svn-build
